/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package gov.anl.aps.dm.portal.model.entities;

import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author sveseli
 */
@Entity
@Table(name = "policy_type")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "PolicyType.findAll", query = "SELECT p FROM PolicyType p"),
    @NamedQuery(name = "PolicyType.findById", query = "SELECT p FROM PolicyType p WHERE p.id = :id"),
    @NamedQuery(name = "PolicyType.findByName", query = "SELECT p FROM PolicyType p WHERE p.name = :name"),
    @NamedQuery(name = "PolicyType.findByDescription", query = "SELECT p FROM PolicyType p WHERE p.description = :description"),
    @NamedQuery(name = "PolicyType.findByHandlerName", query = "SELECT p FROM PolicyType p WHERE p.handlerName = :handlerName"),
    @NamedQuery(name = "PolicyType.findByDefaultPolicyValue", query = "SELECT p FROM PolicyType p WHERE p.defaultPolicyValue = :defaultPolicyValue")})
public class PolicyType extends CloneableEntity
{
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2147483647)
    @Column(name = "name")
    private String name;
    @Size(max = 2147483647)
    @Column(name = "description")
    private String description;
    @Size(max = 2147483647)
    @Column(name = "handler_name")
    private String handlerName;
    @Size(max = 2147483647)
    @Column(name = "default_policy_value")
    private String defaultPolicyValue;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyType")
    private List<ExperimentPolicy> experimentPolicyList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyType")
    private List<TemplatePolicy> templatePolicyList;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "policyType")
    private List<AllowedPolicyValue> allowedPolicyValueList;

    public PolicyType() {
    }

    public PolicyType(Integer id) {
        this.id = id;
    }

    public PolicyType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getHandlerName() {
        return handlerName;
    }

    public void setHandlerName(String handlerName) {
        this.handlerName = handlerName;
    }

    public String getDefaultPolicyValue() {
        return defaultPolicyValue;
    }

    public void setDefaultPolicyValue(String defaultPolicyValue) {
        this.defaultPolicyValue = defaultPolicyValue;
    }

    @XmlTransient
    public List<ExperimentPolicy> getExperimentPolicyList() {
        return experimentPolicyList;
    }

    public void setExperimentPolicyList(List<ExperimentPolicy> experimentPolicyList) {
        this.experimentPolicyList = experimentPolicyList;
    }

    @XmlTransient
    public List<TemplatePolicy> getTemplatePolicyList() {
        return templatePolicyList;
    }

    public void setTemplatePolicyList(List<TemplatePolicy> templatePolicyList) {
        this.templatePolicyList = templatePolicyList;
    }

    @XmlTransient
    public List<AllowedPolicyValue> getAllowedPolicyValueList() {
        return allowedPolicyValueList;
    }

    public void setAllowedPolicyValueList(List<AllowedPolicyValue> allowedPolicyValueList) {
        this.allowedPolicyValueList = allowedPolicyValueList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PolicyType)) {
            return false;
        }
        PolicyType other = (PolicyType) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.anl.aps.dm.portal.model.entities.PolicyType[ id=" + id + " ]";
    }
    
}
